%global blender_api 2.75
%global blender_fontdir /usr/share/fonts/blender
%global blenderlib  %{_datadir}/blender/%{blender_api}
%global blenderarch %{_libdir}/blender/%{blender_api}
%define __python %{__python3}
%global pyver %(%{__python} -c "import sys ; print(sys.version[:3])")
%global fontname blender
%global macrosdir %(d=%{_rpmconfigdir}/macros.d; [ -d $d ] || d=%{_sysconfdir}/rpm; echo $d)
%global cyclesflag ON

Name:           blender
Version:        2.75a
Release:        %mkrel 2
Summary:        3D modeling, animation, rendering and post-production
Group:          Graphics
License:        GPLv2
URL:            http://www.blender.org
Source0:        http://download.blender.org/source/%{name}-%{version}.tar.xz
Source1:        blenderplayer.1
Source5:        blender.xml
Source10:       macros.blender
Patch2:         blender-2.73-droid.patch

BuildRequires:	scons >= 1.0
#BuildRequires:	python-scons
BuildRequires:	openal-devel >= 0.0.6-9mdk
BuildRequires:	OpenEXR-devel >= 1.6.1
BuildRequires:  %{_lib}OpenImageIO-devel
BuildRequires:  libsamplerate-devel
BuildRequires:  %{_lib}ao-devel
BuildRequires:	%{_lib}bullet-devel
BuildRequires:	%{_lib}jemalloc-devel
BuildRequires:	esound-devel
BuildRequires:  %{_lib}freealut-devel
BuildRequires:  %{_lib}python3-devel >= 3.4.2
BuildRequires:	ffmpeg-devel >= 0.4.9-1.pre1
BuildRequires:	ftgl-devel
BuildRequires:	gettext-devel
BuildRequires:	libgomp-devel
BuildRequires:	jpeg-devel
BuildRequires:	mesaglu-devel
BuildRequires:  openCOLLADA-devel
BuildRequires:	oggvorbis-devel
BuildRequires:	openssl-devel
BuildRequires:  expat-devel
BuildRequires:  pcre-devel
BuildRequires:  libxml2-devel
BuildRequires:  boost-devel
BuildRequires:  libxi-devel
BuildRequires:  x11-proto-devel
BuildRequires:  fftw-devel
BuildRequires:  ftgl-devel
BuildRequires:  %{_lib}ode-devel
BuildRequires:  %{_lib}openjpeg1-devel
BuildRequires:  %{_lib}qhull-devel
BuildRequires:	png-devel
BuildRequires:	python-devel >= 2.4
BuildRequires:	SDL-devel
BuildRequires:	smpeg-devel
BuildRequires:	subversion
BuildRequires:	tiff-devel
BuildRequires:	X11-devel
BuildRequires:	yasm
BuildRequires:  nasm
BuildRequires:	zlib-devel
BuildRequires:	libtheora-devel
BuildRequires:	ImageMagick
BuildRequires:	libglew-devel
BuildRequires:	cmake
BuildRequires:	%{_lib}OpenColorIO-devel
Requires:	python-imaging >= 1.1.4
Requires:	fonts-ttf-dejavu
Requires:       fonts-ttf-droid
Requires:	python3 >= 3.4.2
Obsoletes: 	blender-rpm-macros <= 2.69
Obsoletes: 	blenderplayer <= 2.69

%description
Blender is the essential software solution you need for 3D, from modeling,
animation, rendering and post-production to interactive creation and playback.
Professionals and novices can easily and inexpensively publish stand-alone,
secure, multi-platform content to the web, CD-ROMs, and other media.


%prep
%setup -qn %{name}-%{version}
%patch2 -p1 -b .droid

find -name '.svn' -print | xargs rm -rf

%build
mkdir cmake-make
cd cmake-make
export CFLAGS="$RPM_OPT_FLAGS -fPIC -funsigned-char -fno-strict-aliasing"
export CXXFLAGS="$CFLAGS"
cmake .. -DCMAKE_INSTALL_PREFIX=%{_prefix} \
%ifnarch %{ix86} x86_64
  -DWITH_RAYOPTIMIZATION=OFF \
%endif
 -DCMAKE_SKIP_RPATH=ON \
 -DBUILD_SHARED_LIBS=OFF \
 -DWITH_FFTW3:BOOL=ON \
 -DWITH_JACK:BOOL=ON \
 -DWITH_CODEC_SNDFILE:BOOL=ON \
 -DWITH_IMAGE_OPENJPEG:BOOL=ON \
 -DWITH_OPENCOLLADA:BOOL=OFF \
 -DWITH_CYCLES:BOOL=%{cyclesflag} \
 -DWITH_FFTW3:BOOL=ON \
 -DWITH_MOD_OCEANSIM:BOOL=ON \
 -DOPENCOLLADA=%{_includedir} \
 -DWITH_IMAGE_REDCODE:BOOL=ON \
 -DWITH_PYTHON:BOOL=ON \
 -DPYTHON_VERSION:STRING=%{pyver} \
 -DWITH_PYTHON_INSTALL:BOOL=OFF \
 -DWITH_CODEC_FFMPEG:BOOL=ON \
 -DWITH_GAMEENGINE:BOOL=ON \
 -DWITH_CXX_GUARDEDALLOC:BOOL=OFF \
 -DWITH_BUILTIN_GLEW=OFF \
 -DWITH_INSTALL_PORTABLE=OFF \
 -DWITH_PYTHON_SAFETY=ON \
 -DWITH_PLAYER=ON \
 -DWITH_MEM_JEMALLOC=ON \
 -DBOOST_ROOT=%{_prefix}

###make VERBOSE=1 # %{?_smp_mflags}
%make



%install
cd cmake-make
make install DESTDIR=${RPM_BUILD_ROOT}
cd ..

# Create empty %%{_libdir}/blender/scripts to claim ownership
mkdir -p ${RPM_BUILD_ROOT}%{blenderarch}/{scripts,plugins/sequence,plugins/texture}
find release/datafiles/locale -name '.svn' -exec rm -f {} ';'
cp -R -a -p release/scripts/* ${RPM_BUILD_ROOT}%{blenderlib}/scripts
find ${RPM_BUILD_ROOT}%{blenderlib}/scripts -type f -exec sed -i -e 's/\r$//g' {} \;

# Install hicolor icons.
for i in 16x16 22x22 32x32 48x48 256x256 ; do
  mkdir -p %{buildroot}%{_datadir}/icons/hicolor/${i}/apps
  install -pm 0644 release/freedesktop/icons/${i}/apps/%{name}.png \
    %{buildroot}%{_datadir}/icons/hicolor/${i}/apps/%{name}.png
done

mkdir -p %{buildroot}%{_datadir}/icons/hicolor/scalable/apps
install -pm 0644 release/freedesktop/icons/scalable/apps/%{name}.svg \
    %{buildroot}%{_datadir}/icons/hicolor/scalable/apps/%{name}.svg

install -p -D -m 644 %{SOURCE5} ${RPM_BUILD_ROOT}%{_datadir}/mime/packages/blender.xml

# Plugins are not support now
rm -rf ${RPM_BUILD_ROOT}%{blenderarch}/plugins/*

# menu
mkdir -p %{buildroot}%{_datadir}/applications
cat > %{buildroot}%{_datadir}/applications/%{name}.desktop << EOF
[Desktop Entry]
Name=Blender
Comment=The free open source 3D content creation suite
Exec=%{_bindir}/%{name} -w %f
Icon=%{name}
Terminal=false
Type=Application
Categories=3DGraphics;Graphics;Viewer;X-MandrivaLinux-Multimedia-Graphics;
MimeType=application/x-blender;
InitialPreference=11
EOF

# man page
mkdir -p ${RPM_BUILD_ROOT}/%{_mandir}/man1
%__python doc/manpage/blender.1.py $RPM_BUILD_ROOT%{_bindir}/blender ${RPM_BUILD_ROOT}%{_mandir}/man1/blender.1
install -p -D -m 644 %{SOURCE1} ${RPM_BUILD_ROOT}%{_mandir}/man1/
rm -rf ${RPM_BUILD_ROOT}%{_bindir}/blender-thumbnailer.py
rm -rf ${RPM_BUILD_ROOT}%{_docdir}/blender/*
cp -aR release/datafiles/locale ${RPM_BUILD_ROOT}/%{blenderlib}/datafiles/
rm -rf ${RPM_BUILD_ROOT}/%{blenderlib}/datafiles/fonts
 
 
# rpm macros
mkdir -p ${RPM_BUILD_ROOT}%{macrosdir}

sed -e 's/@VERSION@/%{blender_api}/g' %{SOURCE10} \
     >${RPM_BUILD_ROOT}%{macrosdir}/macros.blender

mkdir -p ${RPM_BUILD_ROOT}/%{blender_fontdir}/
cp -p release/datafiles/fonts/*.ttf.gz \
    ${RPM_BUILD_ROOT}%{blender_fontdir}/


%find_lang %{name}

%post
%{update_menus}
%{update_desktop_database} 

%postun
%{clean_menus}
%{clean_desktop_database} 


%files -f blender.lang
%defattr(-,root,root,-)
%doc release/text/*
%{_bindir}/*
%{_datadir}/applications/*.desktop
%{_datadir}/%{name}
%{_libdir}/%{name}
%{_mandir}/man1/%{name}.*
%{_mandir}/man1/blenderplayer.*
%{_datadir}/mime/packages/%{name}.xml
%{_iconsdir}/hicolor/*/apps/%{name}.*
%{blender_fontdir}/
%{macrosdir}/macros.blender

%changelog
* Fri Jul 24 2015 pp <pp> 2.75a-2pclos2015
- added missing BR jemalloc

* Tue Jul 21 2015 pp <pp> 2.75a-1pclos2015
- update
- disable OPENCOLLADA support for now (fix broken build)

* Thu Apr 02 2015 pinoc <vogtpet at gmail.com> 2.74-1pclos2015
- 2.74

* Sun Jan 11 2015 pinoc <vogtpet at gmail.com> 2.73-1pclos2015
- 2.73
- rebuild acc. Fedora

* Tue Nov 18 2014 bb <bb> 2.70a-2pclos2014
- rebuild ffmpeg 2.4

* Wed Apr 23 2014 pinoc <vogtpet at gmail.com> 2.70a-1pclos2014
- 2.70a
- obsolete blender-rpm-macros, blenderplayer

* Tue Jan 07 2014 pinoc <vogtpet at gmail.com> 2.69-1pclos2014
- 2.69

